build container with a set of repos based on mirroring/ instead of a hardwired list
[build.git] / lbuild-initvm.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
5 0<&-
6
7 #shopt -s huponexit
8
9 COMMAND=$(basename $0)
10 DIRNAME=$(dirname $0)
11 BUILD_DIR=$(pwd)
12
13 # pkgs parsing utilities + lbuild-bridge.sh
14 export PATH=$(dirname $0):$PATH
15
16 # old guests have e.g. mount in /bin but this is no longer part of
17 # the standard PATH in recent hosts after usrmove, so let's keep it simple
18 export PATH=$PATH:/bin:/sbin
19
20 . build.common
21
22 # xxx fixme : we pass $lxc around in functions,
23 # but in fact then we use lxc_root which is a global..
24 # it works, but this really is poor practice
25 # we should have an lxc_root function instead
26 function lxcroot () {
27     local lxc=$1; shift
28     echo /vservers/$lxc
29 }
30
31 # XXX fixme : when creating a 32bits VM we need to call linux32 as appropriate...s
32
33 DEFAULT_FCDISTRO=f29
34 DEFAULT_PLDISTRO=lxc
35 DEFAULT_PERSONALITY=linux64
36 DEFAULT_MEMORY=3072
37
38 ##########
39 # constant
40 PUBLIC_BRIDGE=br0
41
42 # the network interface name as seen from the container
43 VIF_GUEST=eth0
44
45 ##########
46 FEDORA_MIRROR_BASE="http://mirror.onelab.eu/fedora/"
47 FEDORA_MIRROR_KEYS="http://mirror.onelab.eu/keys/"
48 FEDORA_PREINSTALLED="dnf dnf-yum passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
49 DEBIAN_PREINSTALLED="openssh-server openssh-client"
50
51 ########## networking utilities
52 function gethostbyname () {
53     local hostname=$1
54     python -c "import socket; print socket.gethostbyname('"$hostname"')" 2> /dev/null
55 }
56
57 # e.g. 21 -> 255.255.248.0
58 function masklen_to_netmask () {
59     local masklen=$1; shift
60     python <<EOF
61 import sys
62 masklen=$masklen
63 if not (masklen>=1 and masklen<=32):
64   print "Wrong masklen",masklen
65   exit(1)
66 result=[]
67 for i in range(4):
68     if masklen>=8:
69        result.append(8)
70        masklen-=8
71     else:
72        result.append(masklen)
73        masklen=0
74 print ".".join([ str(256-2**(8-i)) for i in result ])
75
76 EOF
77 }
78
79 ##############################
80 # return dnf or debootstrap
81 function package_method () {
82     local fcdistro=$1; shift
83     case $fcdistro in
84         f[0-9]*|centos[0-9]*|sl[0-9]*)
85             echo dnf ;;
86         wheezy|jessie|precise|trusty|utopic|vivid|wily|xenial)
87             echo debootstrap ;;
88         *)
89             echo Unknown distro $fcdistro ;;
90     esac
91 }
92
93 # return arch from debian distro and personality
94 function canonical_arch () {
95     local personality=$1; shift
96     local fcdistro=$1; shift
97     case $(package_method $fcdistro) in
98         dnf)
99             case $personality in
100                 *32) echo i386 ;;
101                 *64) echo x86_64 ;;
102                 *) echo Unknown-arch-1 ;;
103             esac ;;
104         debootstrap)
105             case $personality in
106                 *32) echo i386 ;;
107                 *64) echo amd64 ;;
108                 *) echo Unknown-arch-2 ;;
109             esac ;;
110         *)
111             echo Unknown-arch-3 ;;
112     esac
113 }
114
115 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
116 function almost_empty () {
117     local dir="$1"; shift ;
118     # non existing is fine
119     [ ! -d $dir ] && return 0;
120     # need to have at most one file
121     local count=$(cd $dir; ls | wc -l)
122     [ $count -le 1 ]
123 }
124
125 ##############################
126 function fedora_install() {
127     set -x
128     set -e
129
130     local lxc=$1; shift
131     local lxc_root=$(lxcroot $lxc)
132
133     local cache=/var/cache/lxc/fedora/$arch/${fedora_release}
134     mkdir -p $cache
135
136     (
137         flock --exclusive --timeout 60 200 || { echo "Cache repository is busy." ; return 1 ; }
138
139         if [ ! -e "$cache/rootfs" ]; then
140             echo "Getting cache download in $cache/rootfs ... "
141             fedora_download $cache || { echo "Failed to download 'fedora base'"; return 1; }
142         else
143             echo "Updating cache $cache/rootfs ..."
144             if ! dnf --installroot $cache/rootfs --releasever ${fedora_release} -y --nogpgcheck update ; then
145                 echo "Failed to update 'fedora base', continuing with last known good cache"
146             else
147                 echo "Update finished"
148             fi
149         fi
150
151         echo "Filling $lxc_root from $cache/rootfs ... "
152         rsync -a $cache/rootfs/ $lxc_root/
153
154         return 0
155
156         ) 200> $cache/lock
157
158     return $?
159 }
160
161 function fedora_download() {
162     set -x
163
164     local cache=$1; shift
165
166     # check the mini fedora was not already downloaded
167     INSTALL_ROOT=$cache/partial
168     echo $INSTALL_ROOT
169
170     # download a mini fedora into a cache
171     echo "Downloading fedora minimal ..."
172
173     mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
174
175     mkdir -p $INSTALL_ROOT/etc/yum.repos.d
176     mkdir -p $INSTALL_ROOT/dev
177     mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
178     mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
179
180     # copy yum config and repo files
181     cp /etc/yum.conf $INSTALL_ROOT/etc/
182     cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
183
184     # append fedora repo files with desired ${fedora_release} and $basearch
185     for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
186       sed -i "s/\$basearch/$arch/g; s/\$releasever/${fedora_release}/g;" $f
187     done
188
189     MIRROR_URL=$FEDORA_MIRROR_BASE/releases/${fedora_release}/Everything/$arch/os
190     # since fedora18 the rpms are scattered by first name
191     # first try the second version of fedora-release first
192     RELEASE_URLS=""
193     local subindex
194     for subindex in 3 2 1; do
195         RELEASE_URLS="$RELEASE_URLS $MIRROR_URL/Packages/f/fedora-release-${fedora_release}-1.noarch.rpm"
196     done
197
198     RELEASE_TARGET=$INSTALL_ROOT/fedora-release-${fedora_release}.noarch.rpm
199     local found=""
200     local attempt
201     for attempt in $RELEASE_URLS; do
202         if curl --silent --fail $attempt -o $RELEASE_TARGET; then
203             echo "Successfully Retrieved $attempt"
204             found=true
205             break
206         else
207             echo "Failed (not to worry about) with attempt $attempt"
208         fi
209     done
210     [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
211
212     mkdir -p $INSTALL_ROOT/var/lib/rpm
213     rpm --root $INSTALL_ROOT  --initdb
214     # when installing f12 this apparently is already present, so ignore result
215     rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-${fedora_release}.noarch.rpm || :
216     # however f12 root images won't get created on a f18 host
217     # (the issue here is the same as the one we ran into when dealing with a vs-box)
218     # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
219     # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts
220     #          with file from package filesystem-2.4.30-2.fc12.x86_64
221     # in fact this was - of course - allowed by f12's rpm but later on a fix was made
222     #   http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
223     # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
224     # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
225
226     DNF="dnf --installroot=$INSTALL_ROOT --releasever=${fedora_release} --nogpgcheck -y"
227     echo "$DNF install $FEDORA_PREINSTALLED"
228     $DNF install $FEDORA_PREINSTALLED || { echo "Failed to download rootfs, aborting." ; return 1; }
229
230     mv "$INSTALL_ROOT" "$cache/rootfs"
231     echo "Download complete."
232
233     return 0
234 }
235
236 ##############################
237 function fedora_configure() {
238
239     set -x
240     set -e
241
242     local lxc=$1; shift
243     local fcdistro=$1; shift
244     local lxc_root=$(lxcroot $lxc)
245
246     # disable selinux in fedora
247     mkdir -p $lxc_root/selinux
248     echo 0 > $lxc_root/selinux/enforce
249
250     # enable networking and set hostname
251     cat <<EOF > ${lxc_root}/etc/sysconfig/network
252 NETWORKING=yes
253 EOF
254     cat <<EOF > ${lxc_root}/etc/hostname
255 $GUEST_HOSTNAME
256 EOF
257
258     local dev_path="${lxc_root}/dev"
259     rm -rf $dev_path
260     mkdir -p $dev_path
261     mknod -m 666 ${dev_path}/null c 1 3
262     mknod -m 666 ${dev_path}/zero c 1 5
263     mknod -m 666 ${dev_path}/random c 1 8
264     mknod -m 666 ${dev_path}/urandom c 1 9
265     mkdir -m 755 ${dev_path}/pts
266     mkdir -m 1777 ${dev_path}/shm
267     mknod -m 666 ${dev_path}/tty c 5 0
268     mknod -m 666 ${dev_path}/tty0 c 4 0
269     mknod -m 666 ${dev_path}/tty1 c 4 1
270     mknod -m 666 ${dev_path}/tty2 c 4 2
271     mknod -m 666 ${dev_path}/tty3 c 4 3
272     mknod -m 666 ${dev_path}/tty4 c 4 4
273     mknod -m 600 ${dev_path}/console c 5 1
274     mknod -m 666 ${dev_path}/full c 1 7
275     mknod -m 600 ${dev_path}/initctl p
276     mknod -m 666 ${dev_path}/ptmx c 5 2
277
278     fedora_configure_systemd $lxc
279
280     local guest_ifcfg=${lxc_root}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
281     mkdir -p $(dirname ${guest_ifcfg})
282     # starting with f29, we go for NetworkManager as older network-scripts
283     # is about to be deprecated
284     local nm_controlled=false
285     [[ $fcdistro == f29 ]] && nm_controlled=true
286     [[ $fcdistro == f3[0-9] ]] && nm_controlled=true
287
288     if [ -n "$NAT_MODE" ]; then
289         write_guest_ifcfg_natip $nm_controlled
290     else
291         write_guest_ifcfg_publicip $nm_controlled
292     fi > $guest_ifcfg
293
294     [ -z "$IMAGE" ] && fedora_configure_yum $lxc $fcdistro $pldistro
295
296     return 0
297 }
298
299 # this code of course is for guests that do run on systemd
300 function fedora_configure_systemd() {
301     set -e
302     set -x
303     local lxc=$1; shift
304     local lxc_root=$(lxcroot $lxc)
305
306     # so ignore if we can't find /etc/systemd at all
307     [ -d ${lxc_root}/etc/systemd ] || return 0
308     # otherwise let's proceed
309     ln -sf /lib/systemd/system/multi-user.target ${lxc_root}/etc/systemd/system/default.target
310     touch ${lxc_root}/etc/fstab
311     ln -sf /dev/null ${lxc_root}/etc/systemd/system/udev.service
312 # Thierry - Feb 2013 relying on getty is looking for trouble
313 # so, turning getty off for now instead
314 #    sed -i 's/After=dev-%i.device/After=/' ${lxc_root}/lib/systemd/system/getty\@.service
315     ln -sf /dev/null ${lxc_root}/etc/systemd/system/"getty@.service"
316     rm -f ${lxc_root}/etc/systemd/system/getty.target.wants/*service || :
317 # can't seem to handle this one with systemctl
318     chroot ${lxc_root} $personality chkconfig network on
319 }
320
321 # overwrite container yum config
322 function fedora_configure_yum () {
323     set -x
324     set -e
325     trap failure ERR INT
326
327     local lxc=$1; shift
328     local fcdistro=$1; shift
329     local pldistro=$1; shift
330
331     local lxc_root=$(lxcroot $lxc)
332     # rpm --rebuilddb
333     chroot ${lxc_root} $personality rpm --rebuilddb
334
335     echo "Initializing yum.repos.d in $lxc"
336     rm -f $lxc_root/etc/yum.repos.d/*
337
338     # use mirroring/ stuff instead of a hard-wired config
339     local repofile=$lxc_root/etc/yum.repos.d/building.repo
340     yumconf_mirrors $repofile ${DIRNAME} $fcdistro \
341         "no-exclusion-in-this-context" \
342         $FEDORA_MIRROR_BASE
343     # the keys stuff requires adjustment though
344     sed -i $repofile -e s,'gpgkey=.*',"gpgkey=${FEDORA_MIRROR_KEYS}/RPM-GPG-KEY-fedora-${fedora_release}-primary,"
345
346     # import fedora key so that gpgckeck does not whine or require stdin
347     # required since fedora24
348     rpm --root $lxc_root --import $FEDORA_MIRROR_KEYS/RPM-GPG-KEY-fedora-${fedora_release}-primary
349
350     # for using this script as a general-purpose lxc creation wrapper
351     # just mention 'none' as the repo url
352     if [ -n "$REPO_URL" ] ; then
353         if [ ! -d $lxc_root/etc/yum.repos.d ] ; then
354             echo "WARNING : cannot create myplc repo"
355         else
356             # exclude kernel from fedora repos
357             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
358             for repo in $lxc_root/etc/yum.repos.d/* ; do
359                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude"
360             done
361             # the build repo is not signed at this stage
362             cat > $lxc_root/etc/yum.repos.d/myplc.repo <<EOF
363 [myplc]
364 name= MyPLC
365 baseurl=$REPO_URL
366 enabled=1
367 gpgcheck=0
368 EOF
369         fi
370     fi
371 }
372
373 ##############################
374 # apparently ubuntu exposes a mirrors list by country at
375 # http://mirrors.ubuntu.com/mirrors.txt
376 # need to specify the right mirror for debian variants like ubuntu and the like
377 function debian_mirror () {
378     local fcdistro=$1; shift
379     case $fcdistro in
380         wheezy|jessie)
381             echo http://ftp2.fr.debian.org/debian/ ;;
382         precise|trusty|utopic|vivid|wily|xenial)
383             echo http://www-ftp.lip6.fr/pub/linux/distributions/Ubuntu/archive/ ;;
384         *) echo unknown distro $fcdistro; exit 1;;
385     esac
386 }
387
388 function debian_install () {
389     set -e
390     set -x
391     local lxc=$1; shift
392     local lxc_root=$(lxcroot $lxc)
393     mkdir -p $lxc_root
394     local arch=$(canonical_arch $personality $fcdistro)
395     local mirror=$(debian_mirror $fcdistro)
396     debootstrap --no-check-gpg --arch $arch $fcdistro $lxc_root $mirror
397     # just like with fedora we ensure a few packages get installed as well
398     # not started yet
399     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get update"
400     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get -y install $DEBIAN_PREINSTALLED"
401     chroot ${lxc_root} $personality apt-get update
402     chroot ${lxc_root} $personality apt-get -y install $DEBIAN_PREINSTALLED
403     # configure hostname
404     cat <<EOF > ${lxc_root}/etc/hostname
405 $GUEST_HOSTNAME
406 EOF
407
408 }
409
410 function debian_configure () {
411     local guest_interfaces=${lxc_root}/etc/network/interfaces
412     ( [ -n "$NAT_MODE" ] && write_guest_interfaces_natip || write_guest_interfaces_publicip ) > $guest_interfaces
413 }
414
415 function write_guest_interfaces_natip () {
416     cat <<EOF
417 auto $VIF_GUEST
418 iface $VIF_GUEST inet dhcp
419 EOF
420 }
421
422 function write_guest_interfaces_publicip () {
423     cat <<EOF
424 auto $VIF_GUEST
425 iface $VIF_GUEST inet static
426 address $GUEST_IP
427 netmask $NETMASK
428 gateway $GATEWAY
429 EOF
430 }
431 ##############################
432 function setup_lxc() {
433
434     set -x
435     set -e
436     #trap failure ERR INT
437
438     local lxc=$1; shift
439     local fcdistro=$1; shift
440     local pldistro=$1; shift
441     local personality=$1; shift
442
443     local lxc_root=$(lxcroot $lxc)
444
445     # create lxc container
446
447     pkg_method=$(package_method $fcdistro)
448     case $pkg_method in
449         dnf)
450             if [ -z "$IMAGE" ]; then
451                 fedora_install $lxc ||  { echo "failed to install fedora root image"; exit 1 ; }
452                 # this appears to be safer; observed in Jan. 2016 on a f23 host and a f14 cached image
453                 # we were getting this message when attempting the first chroot dnf install
454                 # rpmdb: Program version 4.8 doesn't match environment version 5.3
455                 chroot $(lxcroot $lxc) $personality rm -rf /var/lib/rpm/__db.00{0,1,2,3,4,5,6,7,8,9}
456                 chroot $(lxcroot $lxc) $personality rpm --rebuilddb
457             fi
458             fedora_configure $lxc $fcdistro || { echo "failed to configure fedora for a container"; exit 1 ; }
459             ;;
460         debootstrap)
461             if [ -z "$IMAGE" ]; then
462                 debian_install $lxc || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
463             fi
464             debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
465             ;;
466         *)
467             echo "$COMMAND:: unknown package_method - exiting"
468             exit 1
469             ;;
470     esac
471
472     # Enable cgroup -- xxx -- is this really useful ?
473     [ -d $lxc_root/cgroup ] || mkdir $lxc_root/cgroup
474
475     ### set up resolv.conf from host
476     # ubuntu precise and on, /etc/resolv.conf is a symlink to ../run/resolvconf/resolv.conf
477     [ -h $lxc_root/etc/resolv.conf ] && rm -f $lxc_root/etc/resolv.conf
478     cp /etc/resolv.conf $lxc_root/etc/resolv.conf
479     ### and /etc/hosts for at least localhost
480     [ -f $lxc_root/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $lxc_root/etc/hosts
481
482     # grant ssh access from host to guest
483     mkdir -p $lxc_root/root/.ssh
484     cat /root/.ssh/id_rsa.pub >> $lxc_root/root/.ssh/authorized_keys
485     chmod 700 $lxc_root/root/.ssh
486     chmod 600 $lxc_root/root/.ssh/authorized_keys
487
488     # don't keep the input xml, this can be retrieved at all times with virsh dumpxml
489     local config_xml=/tmp/$lxc.xml
490     ( [ -n "$NAT_MODE" ] && write_lxc_xml_natip $lxc || write_lxc_xml_publicip $lxc ) > $config_xml
491
492     # define lxc container for libvirt
493     virsh -c lxc:/// define $config_xml
494
495     return 0
496 }
497
498 # this part does not belong in a domain any more
499 # but goes in a network object of its own existence
500 #      <network>
501 #        <name>host-bridge</name>
502 #        <forward mode="bridge"/>
503 #        <bridge name="br0"/>
504 #      </network>
505 #
506
507 function write_lxc_xml_publicip () {
508     local lxc=$1; shift
509     local lxc_root=$(lxcroot $lxc)
510     cat <<EOF
511 <domain type='lxc'>
512   <name>$lxc</name>
513   <memory>$MEMORY</memory>
514   <os>
515     <type arch='$arch2'>exe</type>
516     <init>/sbin/init</init>
517   </os>
518   <features>
519     <acpi/>
520   </features>
521   <vcpu>1</vcpu>
522   <clock offset='utc'/>
523   <on_poweroff>destroy</on_poweroff>
524   <on_reboot>restart</on_reboot>
525   <on_crash>destroy</on_crash>
526   <devices>
527     <emulator>/usr/libexec/libvirt_lxc</emulator>
528     <filesystem type='mount'>
529       <source dir='$lxc_root'/>
530       <target dir='/'/>
531     </filesystem>
532     <interface type="bridge">
533       <source bridge="$PUBLIC_BRIDGE"/>
534       <target dev='$VIF_HOST'/>
535     </interface>
536     <console type='pty' />
537   </devices>
538 </domain>
539 EOF
540 }
541
542 # grant build guests the ability to do mknods
543 function write_lxc_xml_natip () {
544     local lxc=$1; shift
545     local lxc_root=$(lxcroot $lxc)
546     cat <<EOF
547 <domain type='lxc'>
548   <name>$lxc</name>
549   <memory>$MEMORY</memory>
550   <os>
551     <type arch='$arch2'>exe</type>
552     <init>/sbin/init</init>
553   </os>
554   <features>
555     <acpi/>
556     <capabilities policy='default'>
557       <mknod state='on'/>
558     </capabilities>
559   </features>
560   <vcpu>1</vcpu>
561   <clock offset='utc'/>
562   <on_poweroff>destroy</on_poweroff>
563   <on_reboot>restart</on_reboot>
564   <on_crash>destroy</on_crash>
565   <devices>
566     <emulator>/usr/libexec/libvirt_lxc</emulator>
567     <filesystem type='mount'>
568       <source dir='$lxc_root'/>
569       <target dir='/'/>
570     </filesystem>
571     <interface type="network">
572       <source network="default"/>
573     </interface>
574     <console type='pty' />
575   </devices>
576 </domain>
577 EOF
578 }
579
580 # this one is dhcp-based
581 function write_guest_ifcfg_natip () {
582     local nm_controlled=$1; shift
583     cat <<EOF
584 DEVICE=$VIF_GUEST
585 BOOTPROTO=dhcp
586 ONBOOT=yes
587 TYPE=Ethernet
588 MTU=1500
589 EOF
590     [ "$nm_controlled" == true ] || echo NM_CONTROLLED=no
591 }
592
593 # use fixed GUEST_IP as specified by GUEST_HOSTNAME
594 function write_guest_ifcfg_publicip () {
595     local nm_controlled=$1; shift
596     cat <<EOF
597 DEVICE=$VIF_GUEST
598 BOOTPROTO=static
599 ONBOOT=yes
600 HOSTNAME=$GUEST_HOSTNAME
601 IPADDR=$GUEST_IP
602 NETMASK=$NETMASK
603 GATEWAY=$GATEWAY
604 TYPE=Ethernet
605 MTU=1500
606 EOF
607     [ "$nm_controlled" == true ] || echo NM_CONTROLLED=no
608 }
609
610 function devel_or_test_tools () {
611
612     set -x
613     set -e
614     trap failure ERR INT
615
616     local lxc=$1; shift
617     local fcdistro=$1; shift
618     local pldistro=$1; shift
619     local personality=$1; shift
620
621     local lxc_root=$(lxcroot $lxc)
622
623     local pkg_method=$(package_method $fcdistro)
624
625     local pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
626
627     ### install individual packages, then groups
628     # get target arch - use uname -i here (we want either x86_64 or i386)
629
630     local lxc_arch=$(chroot ${lxc_root} $personality uname -i)
631     # on debian systems we get arch through the 'arch' command
632     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot ${lxc_root} $personality arch)
633
634     local packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
635     local groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
636
637     case "$pkg_method" in
638         dnf)
639             # --allowerasing required starting with fedora24
640             #
641             local has_dnf=""
642             chroot ${lxc_root} $personality dnf --version && has_dnf=true
643             if [ -n "$has_dnf" ]; then
644                 echo "container has dnf - invoking with --allowerasing"
645                 local pkg_installer="dnf -y install --allowerasing"
646                 local grp_installer="dnf -y groupinstall --allowerasing"
647             else
648                 echo "container has only dnf"
649                 local pkg_installer="dnf -y install"
650                 local grp_installer="dnf -y groupinstall"
651             fi
652             [ -n "$packages" ] && chroot ${lxc_root} $personality $pkg_installer $packages
653             for group_plus in $groups; do
654                 local group=$(echo $group_plus | sed -e "s,+++, ,g")
655                 chroot ${lxc_root} $personality $grp_installer "$group"
656             done
657             # store current rpm list in /init-lxc.rpms in case we need to check the contents
658             chroot ${lxc_root} $personality rpm -aq > $lxc_root/init-lxc.rpms
659             ;;
660         debootstrap)
661             # for ubuntu
662             if grep -iq ubuntu /vservers/$lxc/etc/lsb-release 2> /dev/null; then
663                 # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
664                 # we need at least to add the 'universe' feed for python-rpm
665                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
666                 # also adding a link to updates sounds about right
667                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
668                 # tell apt about the changes
669                 chroot /vservers/$lxc apt-get update
670             fi
671             for package in $packages ; do
672                 # container not started yet
673                 #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get install -y $package" || :
674                 chroot ${lxc_root} $personality apt-get install -y $package || :
675             done
676             ### xxx todo install groups with apt..
677             ;;
678         *)
679             echo "unknown pkg_method $pkg_method"
680             ;;
681     esac
682
683     return 0
684 }
685
686 function post_install () {
687     local lxc=$1; shift
688     local personality=$1; shift
689     local lxc_root=$(lxcroot $lxc)
690     # setup localtime from the host
691     cp /etc/localtime $lxc_root/etc/localtime
692     sshd_disable_password_auth $lxc
693     # post install hook
694     [ -n "$NAT_MODE" ] && post_install_natip $lxc $personality || post_install_myplc $lxc $personality
695     # start the VM unless specified otherwise
696     if [ -n "$START_VM" ] ; then
697         echo Starting guest $lxc
698         virsh -c lxc:/// start $lxc
699         if [ -n "$NAT_MODE" ] ; then
700             wait_for_ssh $lxc
701         else
702             wait_for_ssh $lxc $GUEST_IP
703         fi
704     fi
705 }
706
707 # just in case, let's stay on the safe side
708 function sshd_disable_password_auth () {
709     local lxc=$1; shift
710     local lxc_root=$(lxcroot $lxc)
711     sed --in-place=.password -e 's,^#\?PasswordAuthentication.*,PasswordAuthentication no,' \
712         $lxc_root/etc/ssh/sshd_config
713 }
714
715 function post_install_natip () {
716
717     set -x
718     set -e
719     trap failure ERR INT
720
721     local lxc=$1; shift
722     local personality=$1; shift
723     local lxc_root=$(lxcroot $lxc)
724
725 ### From myplc-devel-native.spec
726 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
727     cat << EOF | chroot ${lxc_root} $personality bash -x
728
729     # customize root's prompt
730     /bin/cat << PROFILE > /root/.profile
731 export PS1="[$lxc] \\w # "
732 PROFILE
733
734 EOF
735
736 }
737
738 function post_install_myplc  () {
739     set -x
740     set -e
741     trap failure ERR INT
742
743     local lxc=$1; shift
744     local personality=$1; shift
745     local lxc_root=$(lxcroot $lxc)
746
747 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
748     cat << EOF | chroot ${lxc_root} $personality bash -x
749
750     # create /etc/sysconfig/network if missing
751     [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
752
753     # turn off regular crond, as plc invokes plc_crond
754     /sbin/chkconfig crond off
755
756     # customize root's prompt
757     /bin/cat << PROFILE > /root/.profile
758 export PS1="[$lxc] \\w # "
759 PROFILE
760
761 EOF
762 }
763
764 ########################################
765 # workaround for broken lxc-enter-namespace
766 # 1st version was relying on virsh net-dhcp-leases
767 # however this was too fragile, would not work for fedora14 containers
768 # WARNING: this code is duplicated in lbuild-nightly.sh
769 function guest_ipv4() {
770     local lxc=$1; shift
771
772     local mac=$(virsh -c lxc:/// domiflist $lxc | egrep 'network|bridge' | awk '{print $5;}')
773     # sanity check
774     [ -z "$mac" ] && return 0
775     arp -en | grep "$mac" | awk '{print $1;}'
776 }
777
778 function wait_for_ssh () {
779     set -x
780     set -e
781
782     local lxc=$1; shift
783
784     # if run in public_ip mode, we know the IP of the guest and it is specified here
785     [ -n "$1" ] && { guest_ip=$1; shift; }
786
787     #wait max 2 min for sshd to start
788     local success=""
789     local current_time=$(date +%s)
790     local stop_time=$(($current_time + 120))
791
792     local counter=1
793     while [ "$current_time" -lt "$stop_time" ] ; do
794          echo "$counter-th attempt to reach sshd in container $lxc ..."
795          [ -z "$guest_ip" ] && guest_ip=$(guest_ipv4 $lxc)
796          [ -n "$guest_ip" ] && ssh -o "StrictHostKeyChecking no" $guest_ip 'uname -i' && {
797                  success=true; echo "SSHD in container $lxc is UP on IP $guest_ip"; break ; } || :
798          counter=$(($counter+1))
799          sleep 10
800          current_time=$(date +%s)
801     done
802
803     # Thierry: this is fatal, let's just exit with a failure here
804     [ -z $success ] && { echo "SSHD in container $lxc could not be reached (guest_ip=$guest_ip)" ; exit 1 ; }
805     return 0
806 }
807
808 ####################
809 function failure () {
810     echo "$COMMAND : Bailing out"
811     exit 1
812 }
813
814 function usage () {
815     set +x
816     echo "Usage: $COMMAND [options] lxc-name             (aka build mode)"
817     echo "Usage: $COMMAND -n hostname [options] lxc-name (aka test mode)"
818     echo "Description:"
819     echo "    This command creates a fresh lxc instance, for building, or running a test myplc"
820     echo "In its first form, spawned VM gets a private IP bridged with virbr0 over dhcp/nat"
821     echo "With the second form, spawned VM gets a public IP bridged on public bridge br0"
822     echo ""
823     echo "Supported options"
824     echo " -n hostname - the hostname to use in container"
825     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
826     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO - current support for fedoras debians ubuntus"
827     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
828     echo " -r repo-url - used to populate yum.repos.d - required in test mode"
829     echo " -P pkgs_file - defines a set of extra packages to install in guest"
830     echo "    by default we use devel.pkgs (build mode) or runtime.pkgs (test mode)"
831     echo " -i image - the location of the rootfs"
832     echo " -m memory - the amount of allocated memory in MB - defaults to $DEFAULT_MEMORY MB"
833     echo " -s do not start VM"
834     echo " -v be verbose"
835     exit 1
836 }
837
838 ### parse args and
839 function main () {
840
841     #set -e
842     #trap failure ERR INT
843
844     if [ "$(id -u)" != "0" ]; then
845           echo "This script should be run as 'root'"
846           exit 1
847     fi
848
849     START_VM=true
850     while getopts "n:f:d:p:r:P:i:m:sv" opt ; do
851         case $opt in
852             n) GUEST_HOSTNAME=$OPTARG;;
853             f) fcdistro=$OPTARG;;
854             d) pldistro=$OPTARG;;
855             p) personality=$OPTARG;;
856             r) REPO_URL=$OPTARG;;
857             P) PREINSTALLED=$OPTARG;;
858             i) IMAGE=$OPTARG;;
859             m) MEMORY=$OPTARG;;
860             s) START_VM= ;;
861             v) VERBOSE=true; set -x;;
862             *) usage ;;
863         esac
864     done
865
866     shift $(($OPTIND - 1))
867
868     # parse fixed arguments
869     [[ -z "$@" ]] && usage
870     local lxc=$1 ; shift
871     local lxc_root=$(lxcroot $lxc)
872
873     # rainchecks
874     almost_empty $lxc_root || \
875         { echo "container $lxc already exists in $lxc_root - exiting" ; exit 1 ; }
876     virsh -c lxc:/// domuuid $lxc >& /dev/null && \
877         { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
878     mkdir -p $lxc_root
879
880     # if IMAGE, copy the provided rootfs to lxc_root
881     if [ -n "$IMAGE" ] ; then
882         [ ! -d "$IMAGE" ] && \
883         { echo "$IMAGE rootfs folder does not exist - exiting" ; exit 1 ; }
884         rsync -a $IMAGE/ $lxc_root/
885     fi
886
887     # check we've exhausted the arguments
888     [[ -n "$@" ]] && usage
889
890     # NAT_MODE is true unless we specified a hostname
891     [ -n "$GUEST_HOSTNAME" ] || NAT_MODE=true
892
893     # set default values
894     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
895     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
896     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
897     [ -z "$MEMORY" ] && MEMORY=$DEFAULT_MEMORY
898
899     # set memory in KB
900     MEMORY=$(($MEMORY * 1024))
901
902     # the set of preinstalled packages - depends on mode
903     if [ -z "$PREINSTALLED" ] ; then
904         if [ -n "$NAT_MODE" ] ; then
905             PREINSTALLED=devel.pkgs
906         else
907             PREINSTALLED=runtime.pkgs
908         fi
909     fi
910
911     if [ -n "$NAT_MODE" ] ; then
912         # we can now set GUEST_HOSTNAME safely
913         [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$(echo $lxc | sed -e 's,\.,-,g')
914     else
915         # as this command can be used in other contexts, not specifying
916         # a repo is considered a warning
917         # use -r none to get rid of this warning
918         if [ "$REPO_URL" == "none" ] ; then
919             REPO_URL=""
920         elif [ -z "$REPO_URL" ] ; then
921             echo "WARNING -- setting up a yum repo is recommended"
922         fi
923     fi
924
925     ##########
926     fedora_release=$(echo $fcdistro | cut -df -f2)
927
928     if [ "$personality" == "linux32" ]; then
929         arch=i386
930         arch2=i686
931     elif [ "$personality" == "linux64" ]; then
932         arch=x86_64
933         arch2=x86_64
934     else
935         echo "Unknown personality: $personality"
936     fi
937
938     # compute networking details for the test mode
939     # (build mode relies entirely on dhcp on the private subnet)
940     if [ -z "$NAT_MODE" ] ; then
941
942         #create_bridge_if_needed $PUBLIC_BRIDGE
943         lbuild-bridge.sh $PUBLIC_BRIDGE
944
945         GUEST_IP=$(gethostbyname $GUEST_HOSTNAME)
946         # use same NETMASK as bridge interface br0
947         masklen=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
948         NETMASK=$(masklen_to_netmask $masklen)
949         GATEWAY=$(ip route show | grep default | awk '{print $3}' | head -1)
950         VIF_HOST="vif$(echo $GUEST_HOSTNAME | cut -d. -f1)"
951     fi
952
953     setup_lxc $lxc $fcdistro $pldistro $personality
954
955     # historically this command is for setting up a build or a test VM
956     # kind of patchy right now though
957     devel_or_test_tools $lxc $fcdistro $pldistro $personality
958
959     # container gets started here
960     post_install $lxc $personality
961
962     echo $COMMAND Done
963
964     exit 0
965 }
966
967 main "$@"